;============================================
; yaHXV (yet another Hex File Viewer)
;
;============================================

.386
.model flat, stdcall
option casemap :none


.nolist
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\gdi32.inc
	include \masm32\include\comctl32.inc
	include \masm32\include\comdlg32.inc
	include \masm32\include\masm32.inc

	includelib \masm32\lib\gdi32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\Comctl32.lib
	includelib \masm32\lib\comdlg32.lib
	includelib \masm32\lib\shell32.lib
	includelib \masm32\lib\oleaut32.lib
	includelib \masm32\lib\ole32.lib
	includelib \masm32\lib\masm32.lib
	includelib \masm32\lib\msvcrt.lib
.list


;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD
OpenFileDlg		PROTO :HWND, :DWORD

$mainWinWidth		EQU 700
$mainWinHeight		EQU 450
$hexWinX		EQU 25
$hexWinY		EQU 50
$hexWinWidth		EQU 650
$hexWinHeight		EQU 325

$hexLineOffset		EQU 5			;Starting X-pos for hex display line
$hexLinesPerPage	EQU 20			;Lines/page
$ASCII_min		EQU 20			;Low ASCII bound
$ASCII_max		EQU 125			;High ASCII bound
$filterChar		EQU '.'			;Character to substitute for non-ASCII values
$maxChar		EQU 255			;Highest displayable character value

$BGcolor		EQU 0FFFFFFH		;Stark white!

;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN
$hexWinAttrs		EQU WS_CHILD OR WS_VISIBLE OR WS_BORDER OR WS_VSCROLL

;===== Menu items: =====
$menuOpen		EQU 1000
$menuExit		EQU 1010

$fileOpenStrLen		EQU 260


;============================================
; DATA
;============================================
.data

;=====  Handles to various stuff:  =====
InstanceHandle		HWND ?
MainWinHandle		HWND ?
HexWinHandle		HWND ?

FileHandle		HANDLE ?
HeapHandle		HANDLE ?

HeapPtr			DD NULL
FontObj			DD ?

FileSize		DD ?
LineHeight		DD ?
StartLine		DD ?
MaxStartLine		DD ?

;===== WORD values: =====
ASCIIfilter		DW TRUE

MainClassName		DB "Hex View", 0
HexClassName		DB "Viewer", 0

MainDisplayName		DB "Hex File Viewer", 0

FileOpenDlgTitle	DB "Pick file to View:", 0
FileStartPathStr	DB ".\*.*", 0

FileOpenOKMsg		DB "File opened successfully.", 0
InfoCaption		DB "Information", 0

FileOpenErrMsg		DB "Sorry, couldn't open that file.", 0
ErrorCaption		DB "Error Message", 0

HexLineOut		LABEL BYTE
  HexLineAddr		DB "########: "
  HexLineHex		DB "## ## ## ## ## ## ## ##  ## ## ## ## ## ## ## ##  "
  HexLineChars		DB "######## ########"
$hexLineLen		EQU $ - HexLineOut
			DB "        ", 0

XlatChars		DB "0123456789ABCDEF"
FontName		DB "Courier New", 0

failmsg1		DB "Child window creation failed!", 0
failmsg2		DB "RegisterClass() failed!", 0
heremsg			DB "I are here", 0
numoutmsg		DB "###"
numoutarea		DB "#", 0
fileshowmsg		DB "File contents: "
fileshowarea		DB "xxxxxxxxxx", 0
beforeallocmsg		db "Before allocation:", 0
afterallocmsg		db "After allocation:", 0
filesizemsg		DB "File size: %lu", 0
memokmsg		DB "Memory allocated OK", 0
memfailmsg		DB "Memory allocation failed!", 0
fontfailmsg		DB "CreateFont() failed!", 0
readfailmsg		DB "File read failed!", 0
maxscrollposmsg		DB "Max. scroll pos.", 0


;============================================
; CODE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX
	INVOKE	WinMain, EAX
	INVOKE	ExitProcess, EAX


;============================================

WinMain		PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, wX:DWORD, wY:DWORD
	LOCAL	hMenu:HMENU

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWinProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	wc.hbrBackground, COLOR_BTNFACE+1
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

; Now register class for hex-view window:
	INVOKE	CreateSolidBrush, $BGcolor
	MOV	wc.hbrBackground, EAX		;COLOR_WINDOW+1
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET HexWinProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET HexClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

; Load menu from resource in .exe:
	INVOKE	LoadMenu, hInst, 600		;menu ID
	MOV	hMenu, eax
; Place window @ center of screen:
	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWinWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWinHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create our main window:
	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainDisplayName,
		$mainWinAttrs, wX, wY, $mainWinWidth, $mainWinHeight,
		NULL, hMenu, hInst, NULL
	MOV	MainWinHandle, EAX
	INVOKE	SetMenu, MainWinHandle, hMenu
	INVOKE	ShowWindow, MainWinHandle, SW_SHOWNORMAL

; Create hex-view window:
	INVOKE	CreateWindowEx, WS_EX_WINDOWEDGE, ADDR HexClassName, NULL,
		$hexWinAttrs, $hexWinX, $hexWinY, $hexWinWidth, $hexWinHeight,
		MainWinHandle, NULL, hInst, NULL
	MOV	HexWinHandle, EAX
	INVOKE	ShowWindow, HexWinHandle, SW_SHOWNORMAL

; Get handle to heap memory to allocate later:
	INVOKE	GetProcessHeap
	MOV	HeapHandle, EAX

;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX
	JZ	exit
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit:	MOV	EAX, msg.wParam
	RET

WinMain	ENDP


;====================================================================
; Main Window Proc
;====================================================================

MainWinProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL	fileOpenName[260]:BYTE, scrollInfo:SCROLLINFO
	LOCAL	buffer[100]:BYTE, numBytesRead:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_COMMAND
	JE	docmd
	CMP	EAX, WM_CLOSE
	JE	doexit
	CMP	EAX, WM_CREATE
	JE	docreate

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

docreate:
	MOV	HeapPtr, NULL			;Indicate heap hasn't been allocated.
	XOR	EAX, EAX
	RET

doexit:
; If heap is allocated, free it up:
	CMP	HeapPtr, NULL
	JNE	exit99
	INVOKE	HeapFree, HeapHandle, 0, HeapPtr
exit99:	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

docmd:
	MOV	AX, WORD PTR wParam
	CMP	AX, $menuOpen
	JE	do_open
	CMP	AX,  $menuExit
	JNE	dodefault
	JMP	doexit

do_open:
	CMP	HeapPtr, NULL			;Is memory currently allocated?
	JE	open5				;No.
	INVOKE	HeapFree, HeapHandle, 0, HeapPtr
open5:	INVOKE	OpenFileDlg, hWin, ADDR fileOpenName
; Look at result from GetOpenFileName() to see if user selected a file
; (result will be zero if user cancels, doesn't select a file or an error occurs):
	OR	EAX, EAX
	JZ	open10
	INVOKE	CreateFile, ADDR fileOpenName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL
; See if file open succeeded:
	CMP	EAX, INVALID_HANDLE_VALUE
	JNE	open20
	INVOKE	MessageBox, hWin, ADDR FileOpenErrMsg, ADDR ErrorCaption, MB_OK
open10:	JMP	open90

open20:	MOV	FileHandle, EAX
	INVOKE	GetFileSize, FileHandle, NULL
	MOV	FileSize, EAX
	INVOKE	HeapAlloc, HeapHandle, 0,  eax
; Check that memory allocation succeeded:
	OR	EAX, EAX
	JNZ	open30
	invoke	MessageBox, hWin, memfailmsg, addr ErrorCaption, MB_OK
	jmp	open40

open30:
	MOV	HeapPtr, EAX			;Save pointer to allocated heap
	INVOKE	ReadFile, FileHandle, HeapPtr, FileSize, ADDR numBytesRead, NULL
	OR	EAX, EAX
	JNZ	open35
	invoke	MessageBox, hWin, ADDR readfailmsg, ADDR ErrorCaption, MB_OK
	jmp	open40

open35:	INVOKE	InvalidateRect, HexWinHandle, NULL, TRUE	;Force re-paint
; Compute max. # of lines for scrolling:
	MOV	EAX, FileSize
	SHR	EAX, 4				;16 chars/line
open33:	MOV	MaxStartLine, EAX
	MOV	scrollInfo.nMax, EAX
	MOV	scrollInfo.cbSize, SIZEOF SCROLLINFO
	MOV	scrollInfo.fMask, SIF_ALL
	MOV	scrollInfo.nPage, $hexLinesPerPage
	XOR	EAX, EAX
	MOV	scrollInfo.nMin, EAX
	MOV	scrollInfo.nPos, EAX
	MOV	StartLine, EAX
	INVOKE	SetScrollInfo, HexWinHandle, SB_VERT, ADDR scrollInfo, TRUE

open40:	INVOKE	CloseHandle, FileHandle
open90:	XOR	EAX, EAX
	RET



MainWinProc	ENDP


;====================================================================
; Hex-View Window Proc
;====================================================================

HexWinProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL	paintRect:RECT, paintStruct:PAINTSTRUCT, hdc:HDC
	LOCAL	hexLineOut[100]:BYTE, lastLineLen:DWORD, hexAddr:DWORD
	LOCAL	hY:DWORD, tm:TEXTMETRIC, scrlInfo:SCROLLINFO, vPos:DWORD
	LOCAL	currHexAddr:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_PAINT
	JE	hpaint
	CMP	EAX, WM_CREATE
	JE	hcreate
	CMP	EAX, WM_VSCROLL
	JE	fw_scroll
	CMP	EAX, WM_CLOSE
	JE	fw_close


; use DefWindowProc for all other messages:
fw_default:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

fw_close:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

hcreate:
	INVOKE	GetDC, hWin
	MOV	hdc, EAX

; Load a fixed-width font for the hex-view window:
	INVOKE	CreateFont, 16, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
		ANSI_CHARSET, OUT_DEFAULT_PRECIS,  CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		FIXED_PITCH OR FF_MODERN, ADDR FontName
;	OR	EAX, EAX			;Did we succeed?
	MOV	FontObj, EAX			;Save this for painting later.

hcr20:	INVOKE	GetTextMetrics, hdc, ADDR tm
	MOV	EAX, tm.tmHeight
	ADD	EAX, tm.tmExternalLeading
	MOV	LineHeight, EAX
	INVOKE	ReleaseDC, hWin, hdc
phx_nada:
	XOR	EAX, EAX
	RET

fw_scroll:
	MOV	scrlInfo.cbSize, SIZEOF scrlInfo
        MOV	scrlInfo.fMask, SIF_ALL
	INVOKE	GetScrollInfo, hWin, SB_VERT, ADDR scrlInfo
	MOV	EAX, scrlInfo.nPos
	MOV	vPos, EAX

; See which scroll action requested:
	MOV	EDX, scrlInfo.nPos		;Pre-load this, used below
	MOV	AX, WORD PTR wParam
	CMP	AX, SB_LINEDOWN
	JE	hx_scrolldown
	CMP	AX, SB_LINEUP
	JE	hx_scrollup
	CMP	AX, SB_PAGEUP
	JE	hx_scrollpup
	CMP	AX, SB_PAGEDOWN
	JE	hx_scrollpdown
	CMP	AX, SB_THUMBTRACK
	JE	hx_thumb
	CMP	AX, SB_TOP
	JE	hx_top
	CMP	AX, SB_BOTTOM
	JNE	fw_default

hx_bottom:
	MOV	EDX, scrlInfo.nMax
	JMP	SHORT hx_doscroll

hx_thumb:
	MOV	EDX, scrlInfo.nTrackPos
	JMP	SHORT hx_doscroll

hx_scrollpdown:
	ADD	EDX, scrlInfo.nPage
	JMP	SHORT hx_doscroll

hx_scrollpup:
	SUB	EDX, scrlInfo.nPage
	JMP	SHORT hx_doscroll	

hx_scrollup:
	DEC	EDX
	JMP	SHORT hx_doscroll

hx_scrolldown:
	INC	EDX
	JMP	SHORT hx_doscroll

hx_top:
	MOV	EDX, scrlInfo.nMin

hx_doscroll:
	MOV	scrlInfo.nPos, EDX		;Stuff in changed pos.
	MOV	scrlInfo.fMask, SIF_POS		;Change pos. only
	INVOKE	SetScrollInfo, hWin, SB_VERT, ADDR scrlInfo, TRUE
	INVOKE	GetScrollInfo, hWin, SB_VERT, ADDR scrlInfo
; Compare Windows-set new position and saved one:
	MOV	EAX, vPos
	MOV	EDX, scrlInfo.nPos
	CMP	EAX, EDX
	JE	hx_noscroll
; Scroll window if changed:
	SUB	EAX, EDX
	MUL	LineHeight
	INVOKE	ScrollWindow, hWin, 0, EAX, NULL, NULL
	INVOKE	UpdateWindow, hWin
hx_noscroll:
	XOR	EAX, EAX
	RET

hpaint:
	CMP	HeapPtr, NULL			;Has file been read?
	JE	phx_nada			;No, so don't do anything
	INVOKE	BeginPaint, hWin, ADDR paintStruct
	MOV	hdc, EAX			;Save handle to DC
	INVOKE	SelectObject, hdc, FontObj	;Put the font into the DC.
	MOV	hY, 0
        INVOKE	GetClientRect, hWin, ADDR paintRect

	MOV	scrlInfo.cbSize, SIZEOF scrlInfo
	MOV	scrlInfo.fMask, SIF_POS
        INVOKE	GetScrollInfo, hWin, SB_VERT, ADDR scrlInfo
	MOV	ESI, scrlInfo.nPos
	SHL	ESI,  4				;X 16 for # lines
	MOV	hexAddr, ESI
	MOV	currHexAddr, ESI
	ADD	ESI, HeapPtr			;Set read point

	PUSH	EBX
	PUSH	ESI
	PUSH 	EDI
; Set up pointers for displaying hex-line text:
	MOV	EAX, FileSize
	MOV	ECX, EAX
	SHR	ECX, 4				;divide/16
	AND	EAX, 0FH			;Get remainder (last short line)
	MOV	lastLineLen, EAX
phx20:	MOV	EAX, hexAddr
	LEA	EDI, HexLineAddr
	CALL	PutHexAddr	
	LEA	EBX, HexLineChars		;Point to place to store chars
	LEA	EDI, HexLineHex			;   and hex
	PUSH	ECX
	MOV	ECX, 16				;Line length
phx40:	LODSB
	MOV	EDX, currHexAddr
	CALL	PutHexChar
	INC	currHexAddr
	LOOP	phx40
	POP	ECX
	MOV	EBX, ECX			;Save our count
	INVOKE	TextOut, hdc, $hexLineOffset, hY, ADDR HexLineOut, $hexLineLen
	ADD	hexAddr, 16
	MOV	EAX, LineHeight
	ADD	hY, EAX				;Next line down
	MOV	ECX, EBX			;Restore count
	LOOP	phx20
	INVOKE	EndPaint, hdc, ADDR paintStruct
	POP	EDI
	POP	ESI
	POP	EBX
	XOR	EAX, EAX
	RET



HexWinProc	ENDP


;=====================================================
; PutHexAddr()
;
; Puts current file address into the hex display line.
;
; On entry,
;   EAX = current address
;   EDI--> Address-output field (XXXXXXXX)
;=====================================================

PutHexAddr	PROC

	PUSH	EBX
	PUSH	ECX
	PUSH	ESI
	MOV	ESI, EAX			;Save address
	LEA	EBX, XlatChars
	MOV	DL, 8				;# of nybbles to do
	MOV	CL, 28				;Initial # of bits to shift
pha10:	MOV	EAX, ESI			;Get back address
	SHR	EAX, CL				;Get the nybble we want in our window
	AND	AL, 0FH				;Mask it off
	XLATB
	STOSB
	SUB	CL, 4				;Reduce shift amount for next nybble
	DEC	DL
	JNZ	pha10
	POP	ESI
	POP	ECX
	POP	EBX
	RET

PutHexAddr	ENDP



;=====================================================
; PutHexChar()
;
; Stuffs current file character into the hex display line.
;
; On entry,
;   AL = character to stuff
;   EBX--> Char-output field (1 byte)
;   EDX = address of current char
;   EDI--> Hex-output field (2 bytes)
;   ECX = current line count (16 ... 1)
;
; EBX & EDI are updated for next byte
;=====================================================

PutHexChar	PROC

	PUSH	ESI
;	INC	EDX
	MOV	ESI, EDX
	MOV	DL, AL				;Save byte.
; 1st: put in hex characters:
	CMP	ESI, FileSize			;Are we at EOF?
	JB	phl10				;Nope
	MOV	AX, '  '
	STOSW					;Stick in 2 spaces
	INC	EDI
	MOV	BYTE PTR [EBX], ' '
	JMP	SHORT phl88

phl10:	PUSH	EBX
	LEA	EBX, XlatChars
	MOV	AH, AL				;Copy byte
	SHR	AL, 4				;High nybble--> low nybble
	XLATB
	STOSB
	MOV	AL, AH				;Get back byte
	AND	AL, 0FH				;Mask off low nybble
	XLATB
	STOSB
	INC	EDI				;Skip over dividing space
	POP	EBX

; 2. Put in ASCII char:
	CMP	ASCIIfilter, TRUE		;Are we filtering characters?
	JNE	phl75				;Nope, just stuff it.
	CMP	DL, $ASCII_min			
	JB	phl60
	CMP	DL, $ASCII_max
	JBE	phl75
phl60:	MOV	DL, $filterChar
phl75:	MOV	BYTE PTR [EBX], DL		;Put in saved char
phl88:	INC	EBX				;Next pos.
	CMP	CX, 9				;In middle of line?
	JNE	phl99
	INC	EBX				;Yes, add center dividing spaces
	INC	EDI
phl99:	POP	ESI
	RET

PutHexChar	ENDP



OpenFileDlg	PROC	hWin:HWND, fileOpenNamePtr:DWORD
	LOCAL	ofn:OPENFILENAME
	local	buffer[40]:byte

; First, zero out entire structure:
	PUSH	EDI
	LEA	EDI, ofn
	MOV	ECX, SIZEOF OPENFILENAME
	XOR	EAX, EAX
	REP	STOSB					;Zero it out.
	POP	EDI

	MOV	ofn.lStructSize, SIZEOF OPENFILENAME
	MOV	EAX, hWin
	MOV	ofn.hWndOwner, EAX
	MOV	EAX, InstanceHandle
	MOV	ofn.hInstance, EAX
	MOV	EAX, fileOpenNamePtr
	MOV	ofn.lpstrFile, EAX
	PUSH	ESI
	PUSH	EDI
	LEA	ESI, FileStartPathStr
	MOV	EDI, EAX				;EAX = fileOpenNamePtr
	CALL	strcpy
	POP	EDI
	POP	ESI
	MOV	ofn.nMaxFile, $fileOpenStrLen
	MOV	ofn.lpstrTitle, OFFSET FileOpenDlgTitle
	MOV	ofn.Flags, OFN_EXPLORER OR OFN_FILEMUSTEXIST OR OFN_LONGNAMES OR OFN_HIDEREADONLY
	INVOKE	GetOpenFileName, ADDR ofn
	
	RET

OpenFileDlg	ENDP



;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP


;====================================================================
; B2A4
;
; Converts binary value to ASCII numeric digits (4 digits, limited to
; maximum value of 9999). Result is leading-zero suppressed.
;
; On entry,
;	EAX = value to convert
;	EDI--> END of location to store digits (4)
;
; Returns: (nothing)
;
;====================================================================

B2A4		PROC
; *** Code courtesy of "dedndave" from The MASM Forum  ***

	MOV	ECX, 4			;4 digits
	JMP	SHORT b2a11
b2a10:	OR	EAX, EAX
        JZ      b2a12			;If # is zero, just put in one '0'.
b2a11:	PUSH	ECX
	MOV	CL, 10
	XOR	EDX, EDX
	DIV	ECX
	OR	DL, '0'			;Binary--> ASCII
	POP	ECX
	MOV	[EDI], DL
	DEC	EDI
	LOOP	b2a10
	RET

b2a12:	MOV	BYTE PTR [EDI],  ' '
	DEC	EDI
	LOOP	b2a12
	RET

B2A4		ENDP


strcpy		PROC

scp10:	MOV	AL, BYTE PTR [ESI]
	MOV	[EDI], BYTE PTR AL
	OR	AL, AL			;Stop on NULL.
	JZ	scp99
	INC	ESI
	INC	EDI
	JMP	scp10

scp99:	RET

strcpy		ENDP




END	start

